<!DOCTYPE html>
<html lang="en">

<head>
  <title>lucky dice</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- font -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

  <style>
    .picture-cover{
      background-image: url("LuckyDiceImages/cover.jpg");
      min-height: 100px;
      margin: 5px;
    }
  </style>
</head>

<body>
  <div class="container-fluid picture-cover">
  </div>
  <div class="container">
    <div class="row">
      <div class="col-5">
        <div class="row  form-group">
          <div class="col-12">
            <h4>Nhập thông tin của bạn</h4>
          </div>
        </div>
        <div class="row  form-group">
          <div class="col-4 ">
            <label style="color:  red" >Username</label>
          </div>
          <div class="col-8">
            <input id="inp-user-name" class="form-control" type="text">
          </div>
        </div>
        <div class="row  form-group">
          <div class="col-4 ">
            <label style="color:  red"  >Firstname</label>
          </div>
          <div class="col-8">
            <input id="inp-first-name" class="form-control" type="text">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-4">
            <label style="color:  red" >Lastname</label>
          </div>
          <div class="col-8">
            <input id="inp-last-name" class="form-control" type="text">
          </div>
        </div>
      </div>
      <div class="col-4 text-center">
        <div class="row form-group">
          <div class="col-12 ">
            <input id="btn-dice" class="btn btn-success button-width w-75 " value="Ném" type="button" onclick="onBtnNemClick()">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-12">
            <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png" style="width: 150px;">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-12">
            <p id="p-notification-dice" >Chúc mừng</p>
          </div>
        </div>
      </div>
      <div class="col-3">
        <div class="row form-group">
          <div class="col-12">
            <p>Voucher</p>
            <p id="p-voucher-id">No ID</p>
            <p id="p-voucher-percent">0%</p>
          </div>
        </div>
        <div class="row form-group">
          <div class="col-12">
            <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/xe-may.jpg" style="width: 100px;">
          </div>
        </div>
      </div>
    </div>
    <div class="row text-center form-group">
      <div class="col-12">
        <button id="btn-dice-history" class="btn btn-info button-width w-25" onclick="onBtnDiceHistoryClick()">Dice History</button>
        <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
        <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
      </div>
    </div>
    <div class="row">
      <div class="col-12">
        <table id="History-placeholder-table" class="table table-striped table-hover border">
          <thead>
            <tr>
              <th>Lượt</th>
              <th>Dice</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td>1</td>
              <td>2</td>
            </tr>
            <tr>
              <td>2</td>
              <td>6</td>
            </tr>
            <tr>
              <td>3</td>
              <td>4</td>
            </tr>
            <tr>
              <td>4</td>
              <td>5</td>
            </tr>
            <tr>
              <td>5</td>
              <td>4</td>
            </tr>
          </tbody>
          
        </table>
      </div>
    </div>
  </div>
  
</body>



<script>
  "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gEND_OF_ROW_COL = -1;

    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onBtnNemClick(){
    //tạo đối tượng để truyền dữ liệu giữa các bước
    var vUserObj = {
      username:"",
      firstname:"",
      lastname:""
    }
    //b1: thu thập dữ liệu
    getData(vUserObj);
    //b2:kiểm tra dữ liệu
    var vIscheck = validateData(vUserObj);
    if(vIscheck){
      var vXmlHttpDice = new XMLHttpRequest();
      //b3: gọi API server
      callApiServerDice(vXmlHttpDice, vUserObj);
      vXmlHttpDice.onreadystatechange = function(){
        if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
          //b4: xử lý response trả về từ server
          processReponse(vXmlHttpDice);
        }
      }
    }
  }

  function onBtnDiceHistoryClick(){
    
    //tạo đối tượng để truyền dữ liệu giữa các bước
    var vUserObj = {
      username:"",
      firstname:"",
      lastname:""
    }
    //b1: thu thập dữ liệu
    getData(vUserObj);
    //b2:kiểm tra dữ liệu
    var vIscheck = validateData(vUserObj);
    if(vIscheck){
      var vXmlHttpDiceHistory = new XMLHttpRequest();
      //b3: gọi API server
      callApiServerDiceHistory(vXmlHttpDiceHistory, vUserObj);
      vXmlHttpDiceHistory.onreadystatechange = function(){
        if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
          //b4: xử lý response trả về từ server
          deleteAllTable();
          createNewTableForDice(vXmlHttpDiceHistory);
        }
      }
    }
  }
  
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function getData(paraDataUser){
    var vInputUserName = document.getElementById("inp-user-name");
    var vInputFirstName = document.getElementById("inp-first-name");
    var vInputLastName = document.getElementById("inp-last-name");
    paraDataUser.username = vInputUserName.value.trim();
    paraDataUser.firstname = vInputFirstName.value.trim();
    paraDataUser.lastname = vInputLastName.value.trim();

  }

  function validateData(paraDataUser){
    if(paraDataUser.username == ""){
      alert("Cần nhập username !!!");
      return false;
    }
    if(paraDataUser.firstname == ""){
      alert("Cần nhập firstname !!!");
      return false;
    }
    if(paraDataUser.lastname == ""){
      alert("Cần nhập lastname !!!");
      return false;
    }
    return true;
  }

  //hàm gọi Api
  function callApiServerDice(paramXmlHttpDice, paramDataUser){
    paramXmlHttpDice.open("POST", gBASE_URL + "/dice", true);
    paramXmlHttpDice.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
    paramXmlHttpDice.send(JSON.stringify(paramDataUser));  //chuyển Json object sang string
  }

  //{"voucher":{"id":81432,"maVoucher":"81432","phanTramGiamGia":"10","ghiChu":"","ngayTao":1614361849000,"ngayCapNhat":1614361849000},"dice":5,"prize":null}
  //hàm xử lý reponse trả về thành công
  function processReponse(paramXmlHttpDice){
    "use strict";
    console.log(paramXmlHttpDice.responseText);
    //parsing JSON to object
    var vResponseToObject = JSON.parse(paramXmlHttpDice.responseText);
    console.log(vResponseToObject);
    //get result dice
    var vDiceReady = vResponseToObject.dice;
    console.log("dice result:= " + vDiceReady);
    //gọi hàm hiển thị dice
    changeDice(vDiceReady);
    //gọi hàm hiện thị lời nhắn
    changeNotification(vDiceReady);
    //gọi hàm hiển thị voucher
    changeVoucherId(vResponseToObject);
    //gọi hàm hiển thị ảnh phần thưởng
    changeGift(vResponseToObject);
  }

  function changeDice(paramDice){
    "use strict";
    var vImgDice = document.getElementById("img-dice");
    switch(paramDice){
      case 1:
        vImgDice.src = "LuckyDiceImages/1.png";
        break;
      case 2:
        vImgDice.src = "LuckyDiceImages/2.png";
        break;
      case 3:
        vImgDice.src = "LuckyDiceImages/3.png";
        break;
      case 4:
        vImgDice.src = "LuckyDiceImages/4.png";
        break;
      case 5:
        vImgDice.src = "LuckyDiceImages/5.png";
        break;
      default:
        vImgDice.src = "LuckyDiceImages/6.png";
        
    }
  }

  //hàm hiện thị lời nhắn
  function changeNotification(paramDice){
    "use strict";
    var vNotification = document.getElementById("p-notification-dice");
    if(paramDice < 4){
      vNotification.innerHTML = ("Chúc mừng bạn may mắn lần sau !!!");
    }else{
      vNotification.innerHTML = ("Chúc mừng bạn hãy chơi tiếp lần nữa !!!");
    }
  }

  function changeVoucherId(paramResponeVoucher){
    "use strict";
    var vPVoucherId = document.getElementById("p-voucher-id");
    var vPVoucherPercent = document.getElementById("p-voucher-percent");
    if(paramResponeVoucher.voucher != null){
      vPVoucherId.innerHTML = paramResponeVoucher.voucher.maVoucher;
      vPVoucherPercent.innerHTML = paramResponeVoucher.voucher.phanTramGiamGia + "%";
    }else{
      vPVoucherId.innerHTML = "";
      vPVoucherPercent.innerHTML = "";
    }
  }

  function changeGift(paramResponePrize){
    var vImgPresent = document.getElementById("img-present");
    var vTenPhanThuong = paramResponePrize.prize;
    switch(vTenPhanThuong){
      case "Mũ":
        vImgPresent.src = "LuckyDiceImages/hat.jpg";
        break;
      case "Áo":
        vImgPresent.src = "LuckyDiceImages/t-shirt.jpg";
        break;
      case "Xe máy":
        vImgPresent.src = "LuckyDiceImages/xe-may.jpg";
        break;
      case "Sổ":
        vImgPresent.src = "LuckyDiceImages/book.jpg";
        break;
      case "Bút":
        vImgPresent.src = "LuckyDiceImages/but.jpg";
        break;
      case "Áo mưa":
        vImgPresent.src = "LuckyDiceImages/ao-mua.jpg";
        break;
      case "Ô tô":
        vImgPresent.src = "LuckyDiceImages/car.jpg";
        break;
      default:
        vImgPresent.src = "LuckyDiceImages/no-present.jpg";
        break;
    }
  }

  //phần làm cho nút nhấn dice history
  //hàm gọi API
  function callApiServerDiceHistory(paramXmlHttpDiceHistory, paramDataUser){
    paramXmlHttpDiceHistory.open("GET", gBASE_URL + "/dice-history?username=" + paramDataUser.username, true);
    paramXmlHttpDiceHistory.send();
  }
  
  function deleteAllTable(){
    document.querySelectorAll("th").forEach(function (data) {data.parentNode.remove();});
    document.querySelectorAll("td").forEach(function (data) {data.parentNode.remove();});
  }

  function createNewTableForDice(paramXmlHttpDiceHistory){
    "use strict";
    console.log(paramXmlHttpDiceHistory.responseText);
    //chuyển sang JSON obj
    var vResponse = JSON.parse(paramXmlHttpDiceHistory.responseText);
    var vTable = document.getElementById("History-placeholder-table");
    var vTableHead = vTable.getElementsByTagName("thead")[0];
    var vRowHead = vTableHead.insertRow(gEND_OF_ROW_COL);
    var vCellHeadCol1 = vRowHead.insertCell(gEND_OF_ROW_COL);
    var vCellHeadCol2 = vRowHead.insertCell(gEND_OF_ROW_COL);
      
    vCellHeadCol1.innerHTML = "<b>Lượt thả xúc xắc</b>";
    vCellHeadCol2.innerHTML = "<b>Mặt xúc xắc thẩy được</b>";

    var vTableBody = vTable.getElementsByTagName("tbody")[0];
    var vDices = vResponse.dices;
    for (var bI = 0; bI < vDices.length; bI++) {
      // tạo dòng mưới cho bẳng và ghi vào các giá trị 
      var vRowBody = vTableBody.insertRow(gEND_OF_ROW_COL);

      var vCellNumber = vRowBody.insertCell(gEND_OF_ROW_COL);
      var vCellDice = vRowBody.insertCell(gEND_OF_ROW_COL);
      
      vCellNumber.innerHTML = bI + 1;
      vCellDice.innerHTML = vDices[bI];
    }
  }
</script>

</body>

</html>